Public Class Form1
    'Gera e exibe permutaes
    Private Sub btnCalcular_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalcular.Click

        lstResultados.Items.Clear()
        txtPermutacoes.Text = ""
        Application.DoEvents()

        Dim matriz() As String
        matriz = txtValores.Text.Split(",")

        'Genera uma coleo para permutar
        'define o total de elementos a permutar
        Dim num_valores As Integer = Val(matriz.Length)
        Dim valores As New Collection

        'Atribui os valores informados aos valores
        For i As Integer = 0 To num_valores - 1
            valores.Add(matriz(i))
        Next i

        ' Gera as permutaes para o no de elementos informados
        Dim permutacoes As Collection = GeraPermutacoes(valores)

        ' Exibe o resultado 
        For Each p As Collection In permutacoes
            Dim texto As String = ""
            For Each item As Object In p
                texto &= item.ToString()
            Next item
            lstResultados.Items.Add(texto)
        Next p

        txtPermutacoes.Text = Format$(Factorial(num_valores))
    End Sub
    ' Retorna o fatorial do nmero
    Private Function Factorial(ByVal num As Long) As Long
        Dim resultado As Long = 1
        For i As Integer = 2 To num
            resultado *= i
        Next i
        Return resultado
    End Function

    ' Gera as permutacoes de valores na coleo valores
    ' Retorna o resultado atravs da coleo 
    Private Function GeraPermutacoes(ByVal valores As Collection) As Collection
        Dim resultados As New Collection
        ' Verifia se existe um nico valor
        If valores.Count = 1 Then
            ' Retorna uma coleo contendo 
            ' a permutao igual a valor nico
            resultados.Add(New Collection)
            resultados.Item(1).Add(valores.Item(1))
            Return resultados
        End If

        ' Cria as permutaes iniciando com cada primeiro item
        resultados = New Collection
        Dim num_valores As Integer = valores.Count
        For i As Integer = 1 To num_valores
            ' Salva o valor
            Dim primeiro_valor As Object = valores.Item(i)

            ' Remove o item.
            valores.Remove(i)

            ' Gera as permuataes dos valores restantes
            Dim nova_permutacoes As Collection = GeraPermutacoes(valores)

            ' Faz a permutao incluino o primeiro_valor
            ' no inicio de cada nova permutao
            For j As Integer = 1 To nova_permutacoes.Count
                ' Inclui o primeiro item
                Dim novo_resultado As New Collection
                novo_resultado.Add(primeiro_valor)
                ' Inclui o resto dos itens na nova permutao
                For k As Integer = 1 To nova_permutacoes(j).Count
                    novo_resultado.Add(nova_permutacoes(j).Item(k))
                Next k

                ' Inclui esta nova permutao aos resultados
                resultados.Add(novo_resultado)
            Next j

            ' Restaura o valor removido
            If i > valores.Count Then
                valores.Add(primeiro_valor)
            Else
                valores.Add(primeiro_valor, , i)
            End If
        Next i

        ' Retorna o resultado
        Return resultados
    End Function
End Class
